/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.msp.npc.GSetNpcBattleState
 *  fire.msp.npc.NpcInfo
 *  fire.pb.GsClient
 *  fire.pb.main.ConfigManager
 *  fire.pb.npc.SNpcShare
 *  fire.pb.timer.NpcLifeTask
 *  mkdb.Executor
 *  mkio.Protocol
 *  xbean.NpcInfo
 */
package fire.pb.map;

import fire.msp.npc.GSetNpcBattleState;
import fire.msp.npc.NpcInfo;
import fire.pb.GsClient;
import fire.pb.main.ConfigManager;
import fire.pb.map.Body;
import fire.pb.npc.SNpcShare;
import fire.pb.timer.NpcLifeTask;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import mkdb.Executor;
import mkio.Protocol;

public class Npc
extends Body {
    public static final int NOT_INBATTLE = 0;
    public static final int INBATTLE = 1;
    public static final int INBATTLE_AND_TIMEOUT = 2;
    private int npcbaseid;
    private String name;
    private int shape;
    private ScheduledFuture<?> future = null;
    private xbean.NpcInfo npcinfo;
    private boolean readonly;

    public xbean.NpcInfo getNpcinfo() {
        return this.npcinfo;
    }

    Npc(long npckey, boolean readonly) {
        super(npckey, 2);
        this.readonly = readonly;
    }

    public Npc copy() {
        Npc copy = new Npc(this.getUniqueID(), this.readonly);
        copy.setScene(this.getScene());
        copy.setPos(this.getPos().copy());
        copy.setNpcId(this.getNpcID());
        copy.setName(this.getName());
        copy.setShape(this.getShape());
        copy.setFuture(this.getFuture());
        return copy;
    }

    public long getNpcKey() {
        return this.getUniqueID();
    }

    public int getNpcID() {
        return this.npcbaseid;
    }

    public void setNpcinfo(xbean.NpcInfo npcinfo) {
        this.npcinfo = npcinfo;
    }

    public void setInBattle(int inBattle) {
        if (this.readonly) {
            throw new UnsupportedOperationException("不能在只读模式下修改NPC的战斗状态");
        }
        this.npcinfo.setIsinbattle(inBattle);
        GsClient.pSendWhileCommit((Protocol)new GSetNpcBattleState(this.getNpcKey(), inBattle));
    }

    public int getInBattle() {
        return this.npcinfo.getIsinbattle();
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getName() {
        return this.name;
    }

    public int getShape() {
        return this.shape;
    }

    public void setShape(int shape) {
        this.shape = shape;
    }

    public ScheduledFuture<?> getFuture() {
        return this.future;
    }

    public void setNpcId(int npcbaseid) {
        this.npcbaseid = npcbaseid;
    }

    public void setFuture(ScheduledFuture<?> future) {
        this.future = future;
    }

    /*
     * WARNING - Removed try catching itself - possible behaviour change.
     */
    public void updateNpcInfo(NpcInfo npcinfo) {
        Npc npc = this;
        synchronized (npc) {
            this.updateMapInfo(npcinfo.sceneid, npcinfo.posx, npcinfo.posy, npcinfo.posz);
            this.setNpcId(npcinfo.npcbaseid);
            this.setName(npcinfo.name);
            this.setShape(npcinfo.shape);
            if (npcinfo.time > 0L) {
                if (this.future != null) {
                    this.future.cancel(false);
                }
                this.future = Executor.getInstance().schedule((Runnable)new NpcLifeTask(npcinfo.npckey, npcinfo.npcbaseid), npcinfo.time, TimeUnit.MILLISECONDS);
            }
        }
    }

    public SNpcShare getNpcShare() {
        return (SNpcShare)ConfigManager.getInstance().getConf(SNpcShare.class).get(this.getNpcID());
    }
}

